package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesEnumExtService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.impp.framework.base.controller.BaseCommonController;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * @Description: 广东麦格纳-通用功能服务
 * @CreateDate: 2021/6/28 下午2:54
 * @Author: simon.song
 */

@Slf4j
@RestController
@Api(description = "通用功能服务")
@RequestMapping(MesCommonConstant.MES_YANFEN + "/common")
public class MesExtCommonController extends BaseCommonController {
    @Autowired
    private IMesEnumExtService enumService;


    @GetMapping(value = "/enumlist")
    @ApiOperation(value = "获取MES系统所有枚举")
    public ResultBean enumlist(@RequestParam(name = "enumName", required = false) String enumName) {
        List<Map<String, Object>> mapList;
        Map<String, Object> map;
        try {
            if (StringUtils.isEmpty(enumName)) {
                mapList = enumService.getAllMesEnums();
                return ResultBean.success("查询成功")
                        .setResultList(mapList)
                        .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
            } else {
                map = enumService.doGetMesEnumByEnumName(enumName);
                return ResultBean.success("查询成功")
                        .setResultObject(map)
                        .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
            }

        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
