package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesEnumExtService;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtEnumUtil;
import cn.estsh.i3plus.mes.apiservice.util.EnumUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @CreateDate: 2021/7/6 下午7:09
 * @Author: simon.song
 */
@Service
@Slf4j
public class MesEnumExtService implements IMesEnumExtService {
    @Override
    public List<Map<String, Object>> getAllMesEnums() {
        Class innerClazz[] = MesExtEnumUtil.class.getDeclaredClasses();// 获取常量类中的所有内部类

        List<Map<String, Object>> enumList = new ArrayList<>();// 所有枚举
        Map<String, Object> enumMap;// 枚举类

        for (Class clazz : innerClazz) {
            enumMap = getEnumByClazzEnum(clazz.getSimpleName(), MesExtEnumUtil.class);
            enumList.add(enumMap);
        }
        return enumList;
    }

    @Override
    public Map<String, Object> doGetMesEnumByEnumName(String enumName) {
        return getEnumByClazzEnum(enumName, MesExtEnumUtil.class);
    }

    @Override
    public Map<String, Object> getEnumByClazzEnum(String enumName, Class clz) {
        return EnumUtil.getEnumByName(clz, enumName);
    }
}
