package cn.estsh.i3plus.ext.mes.pojo.util;

import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * @Description :
 * @Reference :
 * @Author : wangjie
 * @CreateDate : 2018-10-23 15:53
 * @Modify:
 **/

public class MesExtEnumUtil {

    /**
     * 工单类型
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum ORDER_TYPE {
        SORT(10, "排序"),
        UN_SORT(20, "非排序"),
        BTO(30, "BTO");

        private int value;
        private String description;

        private ORDER_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 工单类型标识
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum ORDER_TYPE_IDENTIFICATION {
        N(10, "N"),
        P(20, "P"),
        E(30, "E");

        private int value;
        private String description;

        private ORDER_TYPE_IDENTIFICATION(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 发运单状态
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum SHIPPING_ORDER_STATUS {
        CREATE(10, "创建"),
        PUBLISHED(20, "已发布"),
        SHIPPED(30, "已发运");

        private int value;
        private String description;

        private SHIPPING_ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 设备类型
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum EQUIPMENT_TYPE {
        PHYSICAL(10, "物理设备"),
        VIRTUAL(20, "虚拟设备");

        private int value;
        private String description;

        private EQUIPMENT_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 设备变量类型
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum EQUIPMENT_VARIABLE_TYPE {
        PRODUCTION_PARAM(10, "生产参数"),
        PRODUCTION_PARAM_COMPLETED(20, "生产参数完成");

        private int value;
        private String description;

        private EQUIPMENT_VARIABLE_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 设备点检-点检单类型
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum EQUIPMENT_CHECK_ORDER_TYPE {
        PROCESS_PARAM_INSPECTION(10, "工艺参数点检"),
        EQUIPMENT_INSPECTION(20, "设备点检"),
        FIRST_INSPECTION(30, "首检"),
        ERROR_PROOF_VERIFICATION(40, "防错验证"),
        MOLD_INSPECTION(50, "模具点检"),
        FIXTURE_INSPECTION(60, "工装点检");

        private int value;
        private String description;

        private EQUIPMENT_CHECK_ORDER_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 设备点检-关键类型
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum EQUIPMENT_CHECK_KEY_TYPES {
        DEFAULT(10, "默认"),
        KEY_FEATURES(20, "关键特性"),
        ERROR_PROOF_VERIFICATION(30, "防错验证");

        private int value;
        private String description;

        private EQUIPMENT_CHECK_KEY_TYPES(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 设备点检-点检方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum EQUIPMENT_CHECK_INSPECTION_METHOD {
        BEFORE_PROCESSING(10, "加工前"),
        AFTER_PROCESSING(20, "加工后"),
        ALL_INSPECTIONS(30, "全部点检"),
        EQUIPMENT_NOTIFICATION(40, "设备告知");

        private int value;
        private String description;

        private EQUIPMENT_CHECK_INSPECTION_METHOD(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 设备点检-点检触发方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum EQUIPMENT_CHECK_INSPECTION_TRIGGER_METHOD {
        EQUIPMENT_TRIGGERED(10, "设备触发"),
        PROGRAM_TRIGGERED(20, "程序触发"),
        TIME_TRIGGERED(30, "时间触发");

        private int value;
        private String description;

        private EQUIPMENT_CHECK_INSPECTION_TRIGGER_METHOD(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 设备点检-设备点检配置
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum EQUIPMENT_CHECK_INSPECTION_TRIGGER_CONFIG {
        OPTION1(10, "选项1"),
        OPTION2(20, "选项2"),
        OPTION3(30, "选项3"),
        OPTION4(40, "选项4");

        private int value;
        private String description;

        private EQUIPMENT_CHECK_INSPECTION_TRIGGER_CONFIG(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件发运组-发运单数据来源
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum SHIPPING_GROUP_DATE_SOURCE {
        CUSTOMER_SORT_INFO(10, "客户排序信息");

        private int value;
        private String description;

        private SHIPPING_GROUP_DATE_SOURCE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件发运组-发运组类型
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum SHIPPING_GROUP_TYPE {
        SORT_SHIPPING_ORDERS(10, "排序发运单"),
        UN_SORT_SHIPPING_ORDERS(20, "非排序发运单");

        private int value;
        private String description;

        private SHIPPING_GROUP_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件发运组-扫描确认零件方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum SHIPPING_GROUP_CONFIRM_PART_TYPE {
        SCAN_PART_BARCODE(10, "扫零件条码"),
        CUSTOMER_PART_BARCODE(20, "客户零件条码");

        private int value;
        private String description;

        private SHIPPING_GROUP_CONFIRM_PART_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件发运组-客户信息点
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum SHIPPING_GROUP_CUSTOMER_INFO_POINTS {
        CUSTOMER_SORT_INSTRUCTION_TICKET(10, "客户排序指示票"),
        PAINTING_OFFLINE_POINT(20, "涂装下线点"),
        SYNC_INDICATOR_TICKET(30, "同步指示票");

        private int value;
        private String description;

        private SHIPPING_GROUP_CUSTOMER_INFO_POINTS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件发运组-扫描确认顺序方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum SHIPPING_GROUP_SCAN_CONFIRM_SEQ_MODE {
        DEFAULT_SORT(10, "默认排序"),
        SCAN_POSITION_MATERIAL_RACK(20, "按料架位置扫描");

        private int value;
        private String description;

        private SHIPPING_GROUP_SCAN_CONFIRM_SEQ_MODE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件发运组-扫描方式判断
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum SHIPPING_GROUP_SCAN_METHOD_JUDGMENT {
        PART_NO(10, "零件号"),
        CUSTOMER_PART_NO(20, "客户零件号");

        private int value;
        private String description;

        private SHIPPING_GROUP_SCAN_METHOD_JUDGMENT(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件发运组-圆整方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum SHIPPING_GROUP_ROUND_METHOD {
        GENERATE_BY_ORDER(10, "按订单生成"),
        ADJUST_BY_WINDOW_TIME(20, "按窗口时间调整"),
        ROUND_ACCORDING_TO_PARTS(30, "按零件园整");

        private int value;
        private String description;

        private SHIPPING_GROUP_ROUND_METHOD(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件拉动组-圆整方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum PART_PULL_ROUND_METHOD {
        ROUND_BY_QUANTITY(10, "按数量圆整"),
        ROUND_VIRTUAL_PART_NUMBER(20, "按虚拟总成号圆整"),
        ROUND_DOOR_PANELS_NUMBER(30, "按门板成套圆整");

        private int value;
        private String description;

        private PART_PULL_ROUND_METHOD(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 物料信息-零件类别
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum PART_TYPE {
        ASSEMBLY(10, "总成装配"),
        FIRE_HANDLE(20, "火焰处理"),
        HOT_PRESS(30, "热压");

        private int value;
        private String description;

        private PART_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * PTR零件维护-状态
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum PTR_PART_STATUS {
        CREATE(10, "创建"),
        CLOSE(20, "关闭");

        private int value;
        private String description;

        private PTR_PART_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件生产组-生产方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum PART_GROUP_PRODUCTION {
        SORT_PRODUCTION(10, "排序生产"),
        UN_SORT_PRODUCTION(20, "非排序生产");

        private int value;
        private String description;

        private PART_GROUP_PRODUCTION(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件生产组-订单拆工单的方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum PART_GROUP_SPLIT_ORDER_METHOD {
        min_15(10, "15分钟"),
        min_30(20, "30分钟"),
        min_60(30, "60分钟"),
        min_120(40, "120分钟"),
        shift_code(50, "班次"),
        copy(60, "复制");

        private int value;
        private String description;

        private PART_GROUP_SPLIT_ORDER_METHOD(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件生产组-数据来源
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum PART_GROUP_DATA_SOURCE {
        CUSTOMER_SORT_INFO(10, "客户排序信息"),
        CUSTOMER_ORDER(20, "客户订单");

        private int value;
        private String description;

        private PART_GROUP_DATA_SOURCE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }

    /**
     * 零件生产组明细-圆整方式
     */
    @JsonFormat(
            shape = JsonFormat.Shape.OBJECT
    )
    public static enum PART_GROUP_DETAIL_ROUND_METHOD {
        ROUND_ON_TIME(10, "按时圆整"),
        ROUND_ACCORD_PACK(10, "按包装圆整"),
        ROUND_ACCORD_PART(10, "按零件圆整");

        private int value;
        private String description;

        private PART_GROUP_DETAIL_ROUND_METHOD(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;

            for (int i = 0; i < values().length; ++i) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }

            return tmp;
        }

        public int getValue() {
            return this.value;
        }

        public String getDescription() {
            return this.description;
        }
    }


}
